#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <afblib/hostport.h>
#include <afblib/preforked_service.h>
#include "mxpsession.h"

int main (int argc, char** argv) {
   char* cmdname = *argv++; --argc;
   if (argc != 3) {
      fprintf(stderr, "Usage: %s hostport #processes lockdir\n", cmdname);
      exit(1);
   }
   char* hostport_string = *argv++; --argc;
   hostport hp;
   if (!parse_hostport(hostport_string, &hp, 21021)) {
      fprintf(stderr, "%s: hostport in conformance to RFC 2396 expected\n",
         cmdname);
      exit(1);
   }
   int nof_processes = atoi(*argv++); --argc;
   if (nof_processes <= 0) {
      fprintf(stderr, "%s: number of processes must be a positive\n", cmdname);
      exit(1);
   }

   /* pass lockdir argument to the service */
   run_preforked_service(&hp, mxp_session, nof_processes, argc, argv);
   if (errno == EINTR) {
      exit(0); /* termination initiated by SIGTERM */
   } else {
      perror("run_preforked_service");
      exit(1);
   }
}
